## libchewing 0.10.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24.0...3.31.6)
project(libchewing LANGUAGES C)

set(CMAKE_PROJECT_VERSION 0.10.3)

find_package(Git)
if(Git_FOUND)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} --work-tree ${CMAKE_SOURCE_DIR} describe --dirty --always
        OUTPUT_STRIP_TRAILING_WHITESPACE
        OUTPUT_VARIABLE GIT_DESCRIBE
        ERROR_VARIABLE GIT_DESCRIBE_ERROR
    )
    if(NOT GIT_DESCRIBE_ERROR)
        string(REPLACE "v" "" CMAKE_PROJECT_VERSION ${GIT_DESCRIBE})
    endif()
endif()

set(LIBCHEWING_VERSION ${CMAKE_PROJECT_VERSION})
set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(LIBCHEWING_BINARY_VERSION 1.0.0)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(CTest)
set(CTEST_PARALLEL_LEVEL 1)

if(UNIX)
    set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
    add_compile_definitions(UNDER_POSIX PIC)
endif()

if(MSVC)
    set(CMAKE_C_FLAGS "/utf-8 ${CMAKE_C_FLAGS}")
endif()

include(CheckCCompilerFlag)
include(FetchContent)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
    set(CMAKE_C_FLAGS "-std=gnu99 -finput-charset=utf-8 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_GNU_SOURCE)
    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        if(CMAKE_C_COMPILER_ID MATCHES Clang)
            set(CMAKE_C_FLAGS "-fprofile-instr-generate -fcoverage-mapping ${CMAKE_C_FLAGS}")
        else()
            set(CMAKE_C_FLAGS "--coverage ${CMAKE_C_FLAGS}")
        endif()
    endif()
endif()

add_compile_definitions(HAVE_CONFIG_H=1)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

option(WITH_SQLITE3 "Use sqlite3 to store userphrase" true)

# Use valgrind when testing
option(USE_VALGRIND "Use valgrind when testing" true)

find_package(Corrosion QUIET)
if(NOT Corrosion_FOUND)
    FetchContent_Declare(
        Corrosion
        GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
        GIT_TAG b1fab721655c5c4b1b08a083d3cd29f163af75d0 # v0.5.1
        FIND_PACKAGE_ARGS
    )
    FetchContent_MakeAvailable(Corrosion)
endif()

corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_capi)
corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)

if(WITH_SQLITE3)
    corrosion_set_features(chewing_capi FEATURES sqlite)
    corrosion_set_features(chewing_testhelper FEATURES sqlite)
endif()

if(ENABLE_GCOV)
    corrosion_set_env_vars(chewing_capi CARGO_INCREMENTAL=0)
    corrosion_add_target_local_rustflags(chewing_capi -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
endif()

if(CMAKE_SYSTEM MATCHES "Windows")
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
    corrosion_add_target_rustflags(chewing_capi -Ctarget-feature=+crt-static)
    corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
    corrosion_add_target_rustflags(chewing-cli -Ctarget-feature=+crt-static)
    if(VCPKG_TARGET_TRIPLET)
        corrosion_set_env_vars(chewing-cli VCPKGRS_TRIPLET=${VCPKG_TARGET_TRIPLET})
    endif()
endif()

# Feature probe
include(CheckTypeSize)
check_type_size(uint16_t UINT16_T)

set(CURSES_NEED_WIDE true)
find_package(Curses)

if(WITH_SQLITE3)
    find_package(SQLite3 REQUIRED)
    if(SQLite3_FOUND)
        message(STATUS "Found SQLite3 version ${SQLite3_VERSION}")
        include_directories(SQLite3_INCLUDE_DIRS)
    endif()
endif()

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(INC_DIR ${PROJECT_SOURCE_DIR}/capi/include)
set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)

include(GNUInstallDirs)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/version.texi.in
    ${PROJECT_BINARY_DIR}/doc/version.texi
)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")
set(sysconfdir "\${prefix}/etc")
configure_file(
    ${PROJECT_SOURCE_DIR}/chewing.pc.in
    ${PROJECT_BINARY_DIR}/chewing.pc
    @ONLY
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/capi/include
)

set(ALL_INC
    ${INC_DIR}/chewing.h

    # 0.5.x compatibility headers
    ${INC_DIR}/chewing-compat.h
    ${INC_DIR}/chewingio.h
    ${INC_DIR}/global.h
    ${INC_DIR}/mod_aux.h
)

add_subdirectory(doc)
add_subdirectory(data)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

add_library(libchewing ${ALL_INC} capi/src/chewing.c)
set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
target_compile_definitions(libchewing PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)
target_include_directories(libchewing
    PUBLIC
        $<BUILD_INTERFACE:${INC_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/chewing>
)

corrosion_set_env_vars(chewing_capi
    CHEWING_DATADIR=${CMAKE_INSTALL_FULL_DATADIR}/libchewing
)
target_link_libraries(libchewing PRIVATE chewing_capi)
target_link_libraries(chewing_capi INTERFACE ${SQLite3_LIBRARIES})
if(BUILD_SHARED_LIBS)
    if(CMAKE_C_COMPILER_ID MATCHES GNU|^Clang)
        target_link_options(libchewing
            PRIVATE LINKER:-version-script,${PROJECT_SOURCE_DIR}/capi/src/symbols-elf.map
            PRIVATE LINKER:--gc-sections
            PRIVATE LINKER:-u,chewing_new
            PRIVATE LINKER:-u,chewing_version
        )
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-elf.map
        )
    elseif(CMAKE_C_COMPILER_ID MATCHES AppleClang)
        target_link_options(libchewing
            PRIVATE LINKER:-exported_symbols_list,${PROJECT_SOURCE_DIR}/capi/src/symbols-mach_o.map
            PRIVATE LINKER:-dead_strip
        )
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-mach_o.map
        )
    elseif(MSVC)
        target_link_options(libchewing
            PRIVATE /DEF:${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
            PRIVATE /NODEFAULTLIB:MSVCRT
            PRIVATE /NODEFAULTLIB:MSVCRTD
            PRIVATE /NODEFAULTLIB:LIBCMTD
        )
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
        )
    endif()
endif()

if(MSVC)
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing-msvc
    )
else()
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing
        SOVERSION 3
        VERSION 3.3.1
    )
endif()

install(FILES ${ALL_INC} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/chewing)
install(FILES ${PROJECT_BINARY_DIR}/chewing.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS libchewing
    EXPORT libchewingTargets
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(IMPORTED_RUNTIME_ARTIFACTS chewing-cli DESTINATION ${CMAKE_INSTALL_BINDIR})

# generate CMake Config files
include(CMakePackageConfigHelpers)
set(CONFIG_PACKAGE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Chewing")
configure_package_config_file(ChewingConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfig.cmake"
    INSTALL_DESTINATION ${CONFIG_PACKAGE_DIR})
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/ChewingConfigVersion.cmake"
    VERSION ${LIBCHEWING_VERSION}
    COMPATIBILITY SameMajorVersion)
export(EXPORT libchewingTargets
    NAMESPACE Chewing::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/ChewingTargets.cmake")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfigVersion.cmake"
    DESTINATION ${CONFIG_PACKAGE_DIR})
install(EXPORT libchewingTargets
    FILE ChewingTargets.cmake
    NAMESPACE Chewing::
	DESTINATION ${CONFIG_PACKAGE_DIR})

set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(CPACK_SOURCE_IGNORE_FILES "/build" "/out" "/target" "/\\\\..*")
set(CPACK_SOURCE_GENERATOR TZST)
set(CPACK_SOURCE_PACKAGE_FILE_NAME libchewing-${CMAKE_PROJECT_VERSION})
include(CPack)

=== contrib/Makefile ===
TARGET = simple-select

# FIXME: static build and cross-platform support
LIBCHEWING = $(shell dirname $(shell find .. -name libchewing.so))
CHEWING_LDFLAGS = \
	-L $(LIBCHEWING) -lchewing \
	-Wl,-rpath=$(LIBCHEWING)

all: $(TARGET)

$(TARGET): $(TARGET).c
	$(CC) -o $(TARGET) $(TARGET).c \
		-I ../include \
		-D TEST_HASH_DIR="\"$(PWD)\"" \
		-D TEST_DATA_DIR="\"../data\"" \
		$(CHEWING_LDFLAGS)

check: $(TARGET)
	./$(TARGET)
	@which sqlite3 && echo ".dump" | sqlite3 test.sqlite3

clean:
	rm -f $(TARGET) test.sqlite3

=== data/CMakeLists.txt ===
set(ALL_DATA
    ${DATA_BIN_DIR}/tsi.dat
    ${DATA_BIN_DIR}/word.dat
)

add_custom_target(data ALL DEPENDS ${ALL_DATA})

# We need to copy static data to binary tree when using out of tree build.
set(ALL_STATIC_DATA
    ${DATA_SRC_DIR}/swkb.dat
    ${DATA_SRC_DIR}/symbols.dat
)

add_custom_target(all_static_data
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/swkb.dat ${DATA_BIN_DIR}/swkb.dat
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/symbols.dat ${DATA_BIN_DIR}/symbols.dat
)

# tools
set(ALL_TOOLS init_database)

# tools command
file(MAKE_DIRECTORY ${DATA_BIN_DIR})
set(DATA_COPYRIGHT "Copyright \\(c\\) 2022 libchewing Core Team")
set(DATA_LICENSE "LGPL-2.1-or-later")
set(DATA_VERSION ${LIBCHEWING_VERSION})
add_custom_command(
    OUTPUT
        ${ALL_DATA}
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內建詞庫
        ${DATA_SRC_DIR}/tsi.src tsi.dat
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內建字庫
        ${DATA_SRC_DIR}/word.src word.dat
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內嵌字庫
        ${DATA_SRC_DIR}/mini.src mini.dat
    DEPENDS
        chewing-cli
        ${DATA_SRC_DIR}/mini.src
        ${DATA_SRC_DIR}/word.src
        ${DATA_SRC_DIR}/tsi.src
    WORKING_DIRECTORY ${DATA_BIN_DIR}
)

install(FILES ${ALL_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)
install(FILES ${ALL_STATIC_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)

=== doc/CMakeLists.txt ===
set(INFO_SRC ${PROJECT_SOURCE_DIR}/doc/libchewing.texi)
set(INFO_BIN ${PROJECT_BINARY_DIR}/doc/libchewing.info)

option(BUILD_INFO "Build info doc from texi source")

find_program(MAKEINFO makeinfo)
if(BUILD_INFO AND MAKEINFO)
    add_custom_command(
        OUTPUT
            ${INFO_BIN}
        COMMAND ${MAKEINFO} ${INFO_SRC} -o ${INFO_BIN} -I ${PROJECT_BINARY_DIR}/doc
        DEPENDS
            ${INFO_SRC}
    )
    add_custom_target(INFO ALL DEPENDS ${INFO_BIN})
    add_dependencies(check INFO)

    install(FILES ${INFO_BIN} TYPE INFO)
endif()

if(UNIX)
set(MANPAGES
    chewing-cli.1
    chewing-cli-init-database.1
    chewing-cli-info.1
    chewing-cli-dump.1
)
foreach(man ${MANPAGES})
    file(ARCHIVE_CREATE
        OUTPUT ${PROJECT_BINARY_DIR}/doc/${man}.gz
        PATHS ${PROJECT_SOURCE_DIR}/doc/${man}
        FORMAT raw COMPRESSION GZip
    )
    install(FILES ${PROJECT_BINARY_DIR}/doc/${man}.gz
        DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    )
endforeach()
endif()

=== tests/CMakeLists.txt ===
set(ALL_TESTCASES
    test-bopomofo
    test-config
    test-easy-symbol
    test-error-handling
    test-fullshape
    test-keyboard
    test-keyboardless
    test-logger
    test-regression
    test-reset
    test-special-symbol
    test-struct-size
    test-symbol
    test-userphrase
)
set(ALL_TESTTOOLS
    performance
    randkeystroke
    simulate
    stress
    testchewing
)

if(CURSES_FOUND)
    set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
endif()


set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})

foreach(target ${ALL_TESTCASES})
    add_test(NAME ${target} COMMAND ${target})
    set_tests_properties(
        ${target}
        PROPERTIES
        ENVIRONMENT_MODIFICATION
        "PATH=path_list_prepend:$<TARGET_RUNTIME_DLL_DIRS:${target}>;RUST_LOG=set:trace"
    )
endforeach()

if(USE_VALGRIND)
    find_program(VALGRIND valgrind)
    if(VALGRIND)
        foreach(target ${ALL_TESTCASES})
            add_test("valgrind-${target}" ${VALGRIND} --error-exitcode=255 --leak-check=full ${TEST_BIN_DIR}/${target})
        endforeach()
    endif()
endif()

foreach(target ${ALL_TESTS})
    add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
    target_link_libraries(${target} testhelper)
    target_link_libraries(${target} chewing_testhelper)
    target_link_libraries(${target} libchewing)
    target_compile_definitions(${target} PRIVATE
        CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
        TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
        TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
        TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
    )
    add_dependencies(${target} data all_static_data)
    add_dependencies(check ${target})
endforeach()

add_library(testhelper STATIC
    ${TEST_SRC_DIR}/testhelper.c
)
target_compile_definitions(testhelper PRIVATE
    CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
    TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
    TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
    TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
)

set_target_properties(${ALL_TESTS} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TEST_BIN_DIR}
)

if (CURSES_FOUND)
    target_include_directories(genkeystroke PRIVATE ${CURSES_INCLUDE_DIRS})
    target_link_libraries(genkeystroke ${CURSES_LIBRARIES})
endif()

set(ALL_STATIC_TEST stresstest.py)
foreach(target ${ALL_STATIC_TEST})
    add_custom_target(${target} ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TEST_SRC_DIR}/${target} ${TEST_BIN_DIR}/${target}
    )
    add_dependencies(check ${target})
endforeach()

add_test(NAME cargo-test-lib COMMAND cargo test --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
add_test(NAME cargo-test-capi COMMAND cargo test -p chewing_capi --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
add_test(NAME cargo-test-cli COMMAND cargo test -p chewing-cli)

=== debian/changelog ===
libchewing (0.10.3-1) unstable; urgency=medium

  * New upstream version 0.10.3

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Aug 2025 20:14:33 +0800

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export PATH := /usr/share/cargo/bin:$(PATH)
export CARGO=/usr/share/cargo/bin/cargo
export CARGO_HOME=$(CURDIR)/debian/cargo_home
export CARGO_REGISTRY=$(CURDIR)/debian/cargo_registry
export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

export V=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_auto_clean:
	rm -rf debian/cargo_registry
	rm -f Cargo.lock

execute_before_dh_auto_configure:
	$(CARGO) prepare-debian debian/cargo_registry --link-from-system
	rm -f Cargo.lock

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_INFO=1

override_dh_auto_test:
	dh_auto_test -- -j1 ARGS+=-j1

override_dh_missing:
	rm -f debian/*/usr/share/info/*.info

	dh_missing

=== debian/watch ===
version=4

# See https://davesteele.github.io/development/2015/05/02/debian-watch-file-format-for-signed-github-source-tars/ for GitHub workaround for releases page.

opts="downloadurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/v$1\/@PACKAGE@-$1.tar.zst/,filenamemangle=s/v@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@-$1.tar.zst/" \
https://github.com/chewing/@PACKAGE@/tags .*/v@ANY_VERSION@.tar.gz

## libchewing 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.3)
+set(CMAKE_PROJECT_VERSION 0.11.0)
 
 find_package(Git)
 if(Git_FOUND)
@@ -37,6 +37,9 @@
 include(FetchContent)
 
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
+option(USE_SYSTEM_CHEWING_CLI "Use system-installed chewing-cli to build dictionary" OFF)
+option(BUILD_DOC "Build documentation" ON)
+option(BUILD_DATA "Build chewing dictionaries" ON)
 
 if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
     set(CMAKE_C_FLAGS "-std=gnu99 -finput-charset=utf-8 ${CMAKE_C_FLAGS}")
@@ -71,12 +74,17 @@
 endif()
 
 corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_capi)
-corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
+if(BUILD_TESTING)
+    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
+endif()
 corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)
 
 if(WITH_SQLITE3)
     corrosion_set_features(chewing_capi FEATURES sqlite)
-    corrosion_set_features(chewing_testhelper FEATURES sqlite)
+    if(BUILD_TESTING)
+        corrosion_set_features(chewing_testhelper FEATURES sqlite)
+    endif()
+    corrosion_set_features(chewing-cli FEATURES sqlite)
 endif()
 
 if(ENABLE_GCOV)
@@ -87,7 +95,9 @@
 if(CMAKE_SYSTEM MATCHES "Windows")
     set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
     corrosion_add_target_rustflags(chewing_capi -Ctarget-feature=+crt-static)
-    corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
+    if(BUILD_TESTING)
+        corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
+    endif()
     corrosion_add_target_rustflags(chewing-cli -Ctarget-feature=+crt-static)
     if(VCPKG_TARGET_TRIPLET)
         corrosion_set_env_vars(chewing-cli VCPKGRS_TRIPLET=${VCPKG_TARGET_TRIPLET})
@@ -113,8 +123,6 @@
 set(INC_DIR ${PROJECT_SOURCE_DIR}/capi/include)
 set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
 set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
-set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
-set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
 set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
 set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)
 
@@ -158,17 +166,24 @@
     ${INC_DIR}/mod_aux.h
 )
 
-add_subdirectory(doc)
-add_subdirectory(data)
+if(NOT USE_SYSTEM_CHEWING_CLI)
+    set(CHEWING_CLI $<TARGET_FILE:chewing-cli>)
+endif()
+
+if(BUILD_DOC)
+    add_subdirectory(doc)
+endif()
+
+if(BUILD_DATA)
+    add_subdirectory(data)
+endif()
+
 if(BUILD_TESTING)
     add_subdirectory(tests)
 endif()
 
 add_library(libchewing ${ALL_INC} capi/src/chewing.c)
 set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
-target_compile_definitions(libchewing PRIVATE
-    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
-)
 target_include_directories(libchewing
     PUBLIC
         $<BUILD_INTERFACE:${INC_DIR}>
@@ -233,6 +248,19 @@
     INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+
+if(BUILD_DATA)
+    install(
+        FILES
+            ${PROJECT_BINARY_DIR}/data/dict/chewing/tsi.dat
+            ${PROJECT_BINARY_DIR}/data/dict/chewing/word.dat
+            ${PROJECT_BINARY_DIR}/data/misc/swkb.dat
+            ${PROJECT_BINARY_DIR}/data/misc/symbols.dat
+        DESTINATION
+            ${CMAKE_INSTALL_DATADIR}/libchewing
+    )
+endif()
+
 install(IMPORTED_RUNTIME_ARTIFACTS chewing-cli DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # generate CMake Config files

=== data/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.31.6...3.31.6)
project(libchewing-data LANGUAGES NONE)

option(USE_SYSTEM_CHEWING_CLI "Use system-installed chewing-cli instead of building from source" ON)

if(USE_SYSTEM_CHEWING_CLI)
  find_program(CHEWING_CLI
    chewing-cli
    PATHS "C:\\Program Files\\ChewingTextService"
    REQUIRED
  )
endif()

add_subdirectory(dict/chewing)
add_subdirectory(misc)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 set(INFO_BIN ${PROJECT_BINARY_DIR}/doc/libchewing.info)
 
 option(BUILD_INFO "Build info doc from texi source")
+option(COMPRESS_MANS "Compress man-pages on installation" ON)
 
 find_program(MAKEINFO makeinfo)
 if(BUILD_INFO AND MAKEINFO)
@@ -25,6 +26,8 @@
     chewing-cli-info.1
     chewing-cli-dump.1
 )
+
+if(COMPRESS_MANS)
 foreach(man ${MANPAGES})
     file(ARCHIVE_CREATE
         OUTPUT ${PROJECT_BINARY_DIR}/doc/${man}.gz
@@ -35,4 +38,9 @@
         DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
     )
 endforeach()
+else()
+    install(FILES ${MANPAGES}
+        DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
 endif()
+
+endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,21 @@
     set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
 endif()
 
+add_custom_target(static_data ALL DEPENDS dict_chewing misc
+    COMMAND ${CMAKE_COMMAND} -E copy_if_different
+        ${PROJECT_BINARY_DIR}/data/misc/swkb.dat
+        ${PROJECT_BINARY_DIR}/static_data/swkb.dat
+    COMMAND ${CMAKE_COMMAND} -E copy_if_different
+        ${PROJECT_BINARY_DIR}/data/misc/symbols.dat
+        ${PROJECT_BINARY_DIR}/static_data/symbols.dat
+    COMMAND ${CMAKE_COMMAND} -E copy_if_different
+        ${PROJECT_BINARY_DIR}/data/dict/chewing/tsi.dat
+        ${PROJECT_BINARY_DIR}/static_data/tsi.dat
+    COMMAND ${CMAKE_COMMAND} -E copy_if_different
+        ${PROJECT_BINARY_DIR}/data/dict/chewing/word.dat
+        ${PROJECT_BINARY_DIR}/static_data/word.dat
+)
+set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/static_data)
 
 set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})
 
@@ -59,7 +74,7 @@
         TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
         TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
     )
-    add_dependencies(${target} data all_static_data)
+    add_dependencies(${target} dict_chewing)
     add_dependencies(check ${target})
 endforeach()

=== data/misc/CMakeLists.txt ===
add_custom_command(
  OUTPUT swkb.dat
  COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/swkb.dat
    ${CMAKE_CURRENT_BINARY_DIR}/swkb.dat
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/swkb.dat
)
add_custom_command(
  OUTPUT symbols.dat
  COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/symbols.dat
    ${CMAKE_CURRENT_BINARY_DIR}/symbols.dat
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/symbols.dat
)
add_custom_target(misc ALL DEPENDS swkb.dat symbols.dat)

=== data/dict/chewing/CMakeLists.txt ===
set(TARGETS word.dat tsi.dat alt.dat mini.dat)
add_custom_target(dict_chewing ALL DEPENDS ${TARGETS})

foreach(TARGET ${TARGETS})
  string(REPLACE "dat" "csv" SRC ${TARGET})
  add_custom_command(
    OUTPUT ${TARGET}
    COMMAND ${CHEWING_CLI} init --csv ${CMAKE_CURRENT_SOURCE_DIR}/${SRC} ${TARGET}
    DEPENDS ${SRC}
  )
endforeach()

=== debian/changelog ===
libchewing (0.11.0-1) unstable; urgency=medium

  * New upstream version 0.11.0.
  * d/control: Update Build-Depends.
  * d/symbols: Update symbols for 0.11.0
    * Add Build-Depends-Packages.
  * d/control: Bump Standards-Version to 4.7.3:
    * Remove unnecessary Priority, Rules-Required-Root.
  * d/patches: Remove patch to remove clap_mangen.
  * d/patches: Update dependencies to prevent using sqlite-bundled.
  * d/upstream: Minimal upstream signing key.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 11 Jan 2026 12:08:42 +0800

libchewing (0.10.3-2) unstable; urgency=medium

  [ Peter Michael Green ]
  * Drop unneeded build-dependency for directories crate. (Closes: #1123998)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 28 Dec 2025 01:26:06 +0800

=== debian/control ===
Source: libchewing
Section: libs
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Kan-Ru Chen (陳侃如) <koster@debian.org>,
 Andrew Lee (李健秋) <ajqlee@debian.org>,
 YunQiang Su <syq@debian.org>,
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cargo:native,
 cmake,
 corrosion,
 libncurses-dev,
 librust-aho-corasick-dev (>= 1.1.4-~~),
 librust-anyhow-1+default-dev,
 librust-bumpalo-dev,
 librust-clap-4+default-dev (>= 4.4.18-~~),
 librust-clap-4+derive-dev (>= 4.4.18-~~),
 librust-clap-mangen-dev,
 librust-der-0.7+default-dev (>= 0.7.7-~~),
 librust-der-0.7+std-dev (>= 0.7.7-~~),
 librust-log-0.4+default-dev (>= 0.4.21-~~),
 librust-rusqlite+default-dev (>= 0.28.0-~~),
 librust-tempfile+default-dev (>= 3.10.1-~~),
 libsqlite3-dev,
 libstd-rust-dev,
 python3:native,
 rustc:native (>= 1.70),
 texinfo,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/input-method-team/libchewing
Vcs-Git: https://salsa.debian.org/input-method-team/libchewing.git
Homepage: https://chewing.im

Package: libchewing3
Architecture: any
Multi-Arch: same
Depends:
 libchewing3-data (>= 0.4.0),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 scim-chewing (<< 0.3.3),
Provides:
 libchewing,
Description: intelligent phonetic input method library
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains shared library used by other programs.

Package: libchewing3-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends:
 ${misc:Depends},
Breaks:
 libchewing-data (<= 0.2.7),
Provides:
 libchewing-data,
Description: intelligent phonetic input method library - data files
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains data files of libchewing3.

Package: libchewing3-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libchewing3 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libchewing-dev,
 libchewing1-dev,
 libchewing2-dev,
Description: intelligent phonetic input method library (developer version)
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains static library and header files for developer.

Package: chewing-tools
Architecture: any
Multi-Arch: foreign
Depends:
 libchewing3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: intelligent phonetic input method library (tools)
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains tools for chewing.

=== debian/watch ===
Version: 5
Template: GitHub
Owner: chewing
Project: libchewing
Download-Url-Mangle: s%https://api.github.com/repos/([^/]+)/@PACKAGE@/git/refs/tags/@ANY_VERSION@%https://github.com/$1/@PACKAGE@/releases/download/v$2/@PACKAGE@-$2.tar.zst%g
Pgp-Mode: auto
